<?php
/*
	Plugin Name: OpenGraphProtocol
	Plugin URI: http://javiercasares.com/blog/opengraphprotocol-wordpress-plugin/
	Description: Activa las meta-etiquetas necesarias para el Open Graph Protocol.
	Author: Javier Casares
	Version: 1.0
	Author URI: http://javiercasares.com/
*/

/* og:site_name */
function og_site_name() {
	echo '<meta property="og:site_name" content="'.str_replace('"', "'", get_bloginfo('name')).'">';
}
/* og:title */
function og_title() {
	if(is_front_page()) {
		echo '<meta property="og:title" content="'.str_replace('"', "'", get_bloginfo('name')).'">';
	} elseif(is_single()) {
		echo '<meta property="og:title" content="'.str_replace('"', "'", get_the_title()).'">';
	} elseif(is_page()) {
		echo '<meta property="og:title" content="'.str_replace('"', "'", get_the_title()).'">';
	}
}
/* og:type */
function og_type() {
	if(is_front_page()) {
		echo '<meta property="og:type" content="blog">';
	} elseif(is_single()) {
		echo '<meta property="og:type" content="article">';
	} elseif(is_page()) {
		echo '<meta property="og:type" content="article">';
	}
}
/* og:url */
function og_url() {
	if(is_home()) {
		echo '<meta property="og:url" content="'.home_url().'">';
	} elseif(is_single()) {
		echo '<meta property="og:url" content="'.get_permalink().'">';
	} elseif(is_page()) {
		echo '<meta property="og:url" content="'.get_permalink().'">';
	}
}
/* og:image */
function og_image() {
	global $post;
	if(is_singular()) {
		$first_img = '';
		$output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
		$first_img = $matches[1][0];
		if(trim($first_img)) {
			echo '<meta property="og:image" content="'.trim($first_img).'">';
		}
	}
}
/* og:description */
function get_post_description() {
	global $post;
	if(trim(strip_tags($post->post_excerpt))) {
		$descripcion = trim(strip_tags($post->post_excerpt));
	} elseif(trim(strip_tags($post->post_content))) {
		$descripcion = trim(strip_tags($post->post_content));
	}
	$texto = "";
	if(strlen($descripcion) > '250') {
		$subex = substr($descripcion,0,250-5);
		$exwords = explode(" ",$subex);
		$excut = -(strlen($exwords[count($exwords)-1]));
		if($excut<0) {
			$texto .= substr($subex,0,$excut);
		} else {
			$texto .= $subex;
		}
		$texto .= "[...]";
	} else {
		$texto .= $descripcion;
	}
	return $texto;
}
function og_description() {
	$desc = get_post_description();
	if(is_single()) {
		echo '<meta property="og:description" content="'.str_replace('"', "'", strip_tags($desc)).'">';
	} elseif(is_home()) {
		echo '<meta property="og:description" content="'.str_replace('"', "'", get_bloginfo('description')).'">';
	}
}
/* Generamos los metas */
add_action('wp_head', 'og_site_name');
add_action('wp_head', 'og_title');
add_action('wp_head', 'og_type');
add_action('wp_head', 'og_url');
add_action('wp_head', 'og_image');
add_action('wp_head', 'og_description');
?>